<?php
//require('FeedWriter.php');
class scXmlParser{

    protected $_xmlStream;
    
    protected function _processXmlErrors(){
        $errors = libxml_get_errors();
        foreach ($errors as $error){
            _displayXmlError($error, $xml);
        }
        libxml_clear_errors();
    }

    protected function _displayXmlError($erro, $xml){
        $return = $xml[$error->line -1] . "<br />\n";
        $return .= str_repeat('-', $error->column) . "^\n";

        switch($error->level){
        case LIBXML_ERR_WARNING:
            $return .= "Warning $error->code: ";
            break;
        case LIBXML_ERR_ERROR:
            $return .= "Error $error->code: ";
            break;
        case LIBXML_ERR_FATAL:
            $return .= "Fatal $error->code: ";
            break;
        }
        return $return;
    }

    protected function LoadXmlStream($uri){
        $this->_xmlStream = simplexml_load_file($uri);
        #var_dump($xmlStream);
        if ($this->_xmlStream == FALSE){
            echo $this->_processXmlErrors();
            return;
        }
        $tracks = $this->_xmlStream->documentElement;
        $track = $tracks->childNodes;
    }
    public function CreateRssFeed($uri){
        LoadXmlStream($uri);
    }

    public function GetPlayerCount($uri){
        $this->LoadXmlStream($uri);
        return $this->_xmlStream->track->count();
    }

    public function GetPlayerFeed($uri){
        $this->LoadXmlStream($uri);
        $templatePlayer = '';
        $id = 0;
        foreach($this->_xmlStream->track as $track){
            $encodedUrl = urlencode($track->{'permalink-url'});
            $plainUrl  = ($track->{'permalink-url'});
            $trackTitle = $track->title;
            $userProfile = $track->user->{'permalink-url'};
            $userName = $track->user->username;
            $playerCode = <<<END_TEMPLATE
            <div   id="soundcloud-flash-enclosure-$id"
                    class="soundcloud-flash-enclosure">
                <object type="application/x-shockwave-flash" 
                        data="http://player.soundcloud.com/player.swf?url=$encodedUrl&amp;auto_play=false&amp;player_type=tiny"
                        height="18" width="100%">
                    <param  name="movie"
                            value="http://player.soundcloud.com/player.swf?url=$encodedUrl&amp;auto_play=false&amp;player_type=tiny" />
                    <param name="allowscriptaccess" value="always"/>
                    <param name="wmode" value="transparent"/>
                </object>
                </div>
                <div id="soundcloud-artist-enclosure-$id"
                     class="soundcloud-artist-enclosure">
                <span>
                    <a href="$plainUrl">$trackTitle</a> by
                    <a href="$userProfile">$userName</a>
                </span>
            </div>
END_TEMPLATE;
            $templatePlayer .= $playerCode;
            $id++;
        }
        return $templatePlayer; 
    }
}
